HDU - 3853 LOOPS

Akemi Homura is a Mahou Shoujo (Puella Magi/Magical Girl). 

Homura wants to help her friend Madoka save the world. But because of the plot of the Boss Incubator, she is trapped in a labyrinth called LOOPS. 


The planform of the LOOPS is a rectangle of R*C grids. There is a portal in each grid except the exit grid. It costs Homura 2 magic power to use a portal once. The portal in a grid G(r, c) will send Homura to the grid below G (grid(r+1, c)), the grid on the right of G (grid(r, c+1)), or even G itself at respective probability (How evil the Boss Incubator is)! 
At the beginning Homura is in the top left corner of the LOOPS ((1, 1)), and the exit of the labyrinth is in the bottom right corner ((R, C)). Given the probability of transmissions of each portal, your task is help poor Homura calculate the EXPECT magic power she need to escape from the LOOPS. 


 

Input

The first line contains two integers R and C (2 <= R, C <= 1000). 

The following R lines, each contains C*3 real numbers, at 2 decimal places. Every three numbers make a group. The first, second and third number of the cth group of line r represent the probability of transportation to grid (r, c), grid (r, c+1), grid (r+1, c) of the portal in grid (r, c) respectively. Two groups of numbers are separated by 4 spaces. 

It is ensured that the sum of three numbers in each group is 1, and the second numbers of the rightmost groups are 0 (as there are no grids on the right of them) while the third numbers of the downmost groups are 0 (as there are no grids below them). 

You may ignore the last three numbers of the input data. They are printed just for looking neat. 

The answer is ensured no greater than 1000000. 

Terminal at EOF 

 

Output

A real number at 3 decimal places (round to), representing the expect magic power Homura need to escape from the LOOPS. 
 

Sample Input

2 2
0.00 0.50 0.50    0.50 0.00 0.50
0.50 0.50 0.00    1.00 0.00 0.00

Sample Output

6.000

 

这题本身是一个相对简单的概率dp,但是题目看了好久才懂……

大致是吼姆拉被关在迷宫的(1,1)位置,要想尽办法去到(r,c)位置,然后每次决策消耗两点能量,有三种情况:留在原地,向右走一步和向下走一步,问走到终点的消耗能量期望。

由题意可以列出公式:dp[i][j] = go[i][j][0]*dp[i][j]+go[i][j][1]*dp[i][j+1]+go[i][j][2]*dp[i+1][j]+2,由于无后效性化简可得到dp[i][j] = (go[i][j][1]*dp[i][j+1]+go[i][j][2]*dp[i+1][j]+2)/(1.0-go[i][j][0]),递推就完事了。

AC代码:

#include 

using namespace std;

const int maxn=1010;
double go[maxn][maxn][3];
double dp[maxn][maxn];

int main()
{
    int r,c;
    while(cin>>r>>c)
    {
        for(int i=1;i<=r;i++)
            for(int j=1;j<=c;j++)
                for(int k=0;k<3;k++)
                    scanf("%lf",&go[i][j][k]);

        dp[r][c]=0;

        for(int i=r;i>=1;i--)
        {
            for(int j=c;j>=1;j--)
            {
                if(i==r&&j==c)
                    continue;
                if(go[i][j][0]==1)
                    continue;
                dp[i][j]=(go[i][j][1]*dp[i][j+1]+go[i][j][2]*dp[i+1][j]+2)/(1.0-go[i][j][0]);
            }
        }
        printf("%.3lf\n",dp[1][1]);
    }
    return 0;
}

 

你可能感兴趣的:(训练)